local dragon = {}
dragon.__index = dragon

local function new()
  return setmetatable({}, dragon)
end

function dragon:init(x, y)
  print("dragon init")
  self.startingx = x
  self.startingy = y

  self.x = x
  self.y = y

  self.speed = 100

  self.img = {}
  self.img["left"] = love.graphics.newImage("assets/dragon_left.png")
  self.img["right"] = love.graphics.newImage("assets/dragon_right.png")

  self.w = self.img["left"]:getWidth()
  self.h = self.img["left"]:getHeight()

  self.direction = "right"

  self.dead = false
  self.dying = false
  self.counter = 0 -- dying counter

  self.oType = "dragon"

  self.layer = 3

  table.insert(monsters, self)

end

function dragon:update(dt)

  if self.dying == false then
    self.middlex = self.x + (self.w/2)
    self.middley = self.y + (self.h/2)

    self.angle = math.atan2((player1.y - self.middley), (player1.x - self.middlex))

    self.dx = math.cos(self.angle) * (dt * self.speed)
    self.dy = math.sin(self.angle) * (dt * self.speed)

    self.x = self.x + self.dx
    self.y = self.y + self.dy

    if self.dx < 0 then
      self.direction = "left"
    elseif self.dx > 0 then
      self.direction = "right"
    end

    if cc(self.x + 60, self.y + 60, self.w - 120, self.h - 120, player1.x, player1.y, player1.w, player1.h) then
      player1.hit = true
    end
  else
    self.counter = self.counter + 1
    if self.counter > (60*2) then
      self.dead = true
    end
  end

end

function dragon:draw()

  love.graphics.draw(self.img[self.direction], self.x, self.y)

end

function dragon:keypressed(key)

end

function dragon:keyreleased(key)

end

return setmetatable({new = new},
  {__call = function(_, ...) return new(...) end})
