function cc(ax1,ay1,aw,ah, bx1,by1,bw,bh)

  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function love.load()
  loader = require("tile_loader.Loader")
  loader.path = "maps/"

  font32 = love.graphics.newFont(32)
  love.graphics.setFont(font32)

  -- Load sounds
  sound1 = love.audio.newSource("sound1.ogg", "static")
  diesound = love.audio.newSource("die.ogg", "static")
  winsound = love.audio.newSource("win.ogg", "static")
  lose = love.audio.newSource("lose.ogg", "static")

  -- Loads Camera
  camera = require("camera")
  cam_startx = 0
  cam_starty = 0

  -- Screen globals
  screen_width = love.graphics.getWidth()
  screen_height = love.graphics.getHeight()

  items = {}
  monsters = {}

  -- Player Init
  player = require("player")

  -- Object Init
  object = require("object")

  -- Dragon Init
  --dragon = require("dragon")

  fullscreen = false

  -- 30x22
  --mapHeight = 15*32
  --mapWidth = 15*32

  screen_width = love.graphics.getWidth()
  screen_height = love.graphics.getHeight()

  -- load maps
  world = { 
    {1, 2, 3},
    {1, 2, 3},
    {1, 2, 3},
  }

  activeEnts = {}

  reset()
end

function love.update(dt)

  if won == false and dead == false then
    player1:update(dt)
    for i,v in ipairs(activeEnts) do
      if v.mapx == player1.mapx and v.mapy == player1.mapy then
        v:update(dt)
      end
    end
    for i,v in ipairs(items) do
      if v.mapx == player1.mapx and v.mapy == player1.mapy then
        v:update(dt) 
      end
    end

    for i,v in ipairs(monsters) do
      v:update(dt)
    end

  end

end

function love.draw()

  if won == false then
    for i,v in ipairs(activeEnts) do
      if v.mapx == player1.mapx and v.mapy == player1.mapy then
        v:draw() 
      end
      if v.oType == "finish" then
        if v.mapx == player1.mapx and v.mapy == player1.mapy then
          for j, k in ipairs(items) do
            if cc(v.x, v.y, v.w, v.h, k.x, k.y, k.w, k.h) then
              print("win")
              win()
            end
          end
        end
      end
    end
    player1:draw()
    for i,v in ipairs(items) do
      if v.mapx == player1.mapx and v.mapy == player1.mapy then
        v:draw() 
      end
      if v.inHand == true then
        v.mapx = player1.mapx
        v.mapy = player1.mapy
      end
    end
  end

  for i,v in ipairs(monsters) do
    v:draw()
  end

  -- If player won
  if won == true then
    love.graphics.print("You win!", 100, 100)
  end

  -- If player died
  if dead == true then
    love.graphics.print("You lose!", 100, 100)
  end

end

function love.keypressed(key)

  player1:keypressed(key)
  for i,v in ipairs(activeEnts) do v:keypressed(key) end
  for i,v in ipairs(items) do v:keypressed(key) end
  if key == "f" then
    if fullscreen == false then
      love.graphics.setMode(love.graphics.getWidth(), love.graphics.getHeight(), true)
      fullscreen = true
    elseif fullscreen == true then
      love.graphics.setMode(love.graphics.getWidth(), love.graphics.getHeight(), false)
      fullscreen = false
    end
  elseif key == "g" then
    print(love.timer.getFPS())
  elseif key == "return" then
    if won == true or dead == true then
      reset()
    end
  elseif key == "escape" then
    love.event.quit()
  end

end

function love.keyreleased(key)

  player1:keyreleased(key)

end

function cc(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function win() 
  won = true
  love.audio.rewind(winsound)
  love.audio.play(winsound)
end

function die()
  dead = true
  love.audio.rewind(lose)
  love.audio.play(lose)
end

function reset()

  won = false
  dead = false

  cam = nil
  cam = camera(cam_startx, cam_starty)

  player1 = player()
  player1:init(400, 400)

  local c = 0
  maps = {}
  for y=1, #world do
    maps[y] = {}
    for x=1, #world[y] do
      c = c + 1
      maps[y][x] = loader.load("map" .. c .. ".tmx")
      loadMap(y, x)
    end
  end

end

function loadMap(yy, xx)

  player1.mapy = 1
  player1.mapx = 1

  for x, y, tile in maps[yy][xx]("tiles"):iterate() do
    if tile.properties.solid then
      solid = object()
      solid:init(x*32, y*32, "wall", yy, xx)
    elseif tile.properties.floor then
      floor = object()
      floor:init(x*32, y*32, "floor", yy, xx)
    elseif tile.properties.key then
      key = object()
      key:init(x*32, y*32, "key", yy, xx)
      floor = object()
      floor:init(x*32, y*32, "floor", yy, xx)
    elseif tile.properties.sword then
      sword = object()
      sword:init(x*32, y*32, "sword", yy, xx)
      floor = object()
      floor:init(x*32, y*32, "floor", yy, xx)
    elseif tile.properties.finish then
      finish = object()
      finish:init(x*32, y*32, "finish", yy, xx)
    --elseif tile.properties.dragon then
      --dragon = dragon()
      --dragon:init((30*32)*2 + x*32, (30*22)*2 + y*32, "dragon", yy, xx)
      --floor = object()
      --floor:init(x*32, y*32, "floor", yy, xx)
    end
    --print(tile.properties[1])
  end

end
