local object = {}
object.__index = object

local function new()
  return setmetatable({}, object)
end

function object:init(x, y, oType, yy, xx)

  self.startingx = x
  self.startingy = y

  self.x = x
  self.y = y
  self.mapy = yy
  self.mapx = xx
  self.inHand = false
  self.oType = oType

  if self.oType == "wall" then
    self.w = 32
    self.h = 32
    self.pickupable = false
    self.collideable = true
    self.layer = 1
    table.insert(activeEnts, self)
  elseif self.oType == "floor" then
    self.w = 32
    self.h = 32
    self.pickupable = false
    self.collideable = false
    self.layer = 1
    table.insert(activeEnts, self)
  elseif self.oType == "finish" then
    self.w = 32
    self.h = 32
    self.pickupable = false
    self.collideble = false
    self.layer = 1
    table.insert(activeEnts, self)
  elseif self.oType == "key" then
    self.img = love.graphics.newImage("assets/key.png")
    self.w = self.img:getWidth()
    self.h = self.img:getHeight()
    self.pickupable = true
    self.collideable = false
    self.layer = 3
    table.insert(items, self)
  elseif self.oType == "sword" then
    self.img = love.graphics.newImage("assets/sword.png")
    self.w = self.img:getWidth()
    self.h = self.img:getHeight()
    self.pickupable = true
    self.collideable = false
    self.layer = 3
    table.insert(items, self)
  end

end

function object:update(dt)

  if self.inHand == true then
    self.x = player1.x - player1.pickUpx
    self.y = player1.y - player1.pickUpy
  end

  if self.collideable == true then
    if cc(self.x, self.y, self.w, self.h, player1.x + 10, player1.y + 10, player1.w - 20, player1.h - 20) then
      player1.x = player1.oldx
      player1.y = player1.oldy
    end
  end

end

function object:draw()

  if self.img ~= nil then 
    love.graphics.draw(self.img, self.x, self.y)
  end

  if self.oType == "wall" then
    love.graphics.setColor(200,0,0)
    love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
  elseif self.oType == "floor" then
    love.graphics.setColor(200,0,200)
    love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
  elseif self.oType == "finish" then
    love.graphics.setColor(50, 80, 50)
    love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
  end

  love.graphics.setColor(255,255,255)

end

function object:keypressed(key)

  if key == "o" and self.oType == "key" then
    print(self.mapx .. " " .. self.mapy)
  end

end

function object:keyreleased(key)

end

return setmetatable({new = new},
  {__call = function(_, ...) return new(...) end})
