local player = {}
player.__index = player

local function new()
  return setmetatable({}, player)
end

function player:init(x, y)
  self.w = 32 -- Width
  self.h = 32 -- Height

  self.startingx = x
  self.startingy = y

  self.x = x
  self.y = y

  self.speed = 200 -- Max speed

  self.hit = false

  self.direction = nil

  self.holding = false

  self.mapx = 1
  self.mapy = 1

end

function player:update(dt)

  if self.hit == true then
    die()
  end

  player1.oldx = player1.x
  player1.oldy = player1.y

  -- Handle Camera
  cam.x = self.x + (self.w/2)
  cam.y = self.y + (self.h/2)

  if love.keyboard.isDown("w") then
    self:move("n", dt)
  end

  if love.keyboard.isDown("s") then
    self:move("s", dt)
  end

  if love.keyboard.isDown("a") then
    self:move("w", dt)
  end

  if love.keyboard.isDown("d") then
    self:move("e", dt)
  end

  if self.x < 0 then
    if maps[self.mapy][self.mapx-1] ~= nil then
      self.x = screen_width
      self.mapx = self.mapx - 1
      --loadMap(self.mapy, self.mapx-1)
    end
  elseif self.x > screen_width then
    if maps[self.mapy][self.mapx+1] ~= nil then
      self.x = 1
      self.mapx = self.mapx + 1
      --loadMap(self.mapy, self.mapx+1)
    end
  elseif self.y < 0 then
    if maps[self.mapy-1] ~= nil then
      self.y = screen_height
      self.mapy = self.mapy - 1
      --loadMap(self.mapy-1, self.mapx)
    end
  elseif self.y > screen_height then
    if maps[self.mapy+1] ~= nil then
      self.y = 1
      self.mapy = self.mapy + 1
      --loadMap(self.mapy+1, self.mapx)
    end
  end
end

function player:move(dir, dt)

  if dir == "n" then
    self.y = self.y - (self.speed*dt)
  elseif dir == "s" then
    self.y = self.y + (self.speed*dt)
  elseif dir == "w" then
    self.x = self.x - (self.speed*dt)
  elseif dir == "e" then
    self.x = self.x + (self.speed*dt)
  end

  self.direction = dir

end

function player:draw()

  love.graphics.setColor(255, 255, 0) -- Yellow
  love.graphics.rectangle("fill", self.x, self.y, self.w, self.h) -- Draw players rectangle
  love.graphics.setColor(255, 255, 255) -- Clear/White

  --[[if self.holding == true then
    love.graphics.draw(objects[self.inHand], self.x, self.y)
  ]]--end

end

function player:keypressed(key)

  if key == "return" then
    if self.holding == false then
      for i,v in ipairs(items) do
        if v.mapx == self.mapx and v.mapy == self.mapy then
          if v.pickupable == true then
            if cc(v.x, v.y, v.img:getWidth(), v.img:getHeight(), self.x, self.y, self.w, self.h) then
              v.inHand = true
              self.holding = true
              self.pickUpx, self.pickUpy = self.x - v.x, self.y - v.y
              love.audio.rewind(sound1)
              love.audio.play(sound1)
              break
            end
          end
        end
      end
    elseif self.holding == true then
      for i,v in ipairs(items) do
        if v.inHand == true then 
          v.inHand = false
          self.holding = false
        end
      end
    end
  elseif key == "k" then
    print(self.mapx .. " " .. self.mapy)
  end

end

function player:keyreleased(key)

end

function player:getcoord()
  return self.mapx, self.mapy
end

return setmetatable({new = new},
  {__call = function(_, ...) return new(...) end})
